package test;

public class TestAll extends AbstractTest {

	public static void main(String[] args) {
		TestAll t = new TestAll();
	}

	private AbstractTest[] testSuite;

	public TestAll() {
		this.testName = this.getClass().getName();
	}	
	
	protected void init() {
		super.init();
		this.testSuite = new AbstractTest[] {
				new TestObjectSet(),
				new TestArraySetImpl1(),
				new TestArraySetImpl2(),
				new TestSetIterator(),
				new TestSetIterable(),
				new TestArraySetIterator1(),
				new TestArraySetIterator2(),
				new TestArraySetImpl3(),
				
				new TestOperator(),
				new TestBinaryOperator1(),
				new TestBinaryOperator2(),
				
				new TestUnion1(),
				new TestUnion2(),
				new TestIntersect1(),
				new TestIntersect2(),
				new TestMinus1(),
				new TestMinus2(),

				new TestArrayListSetImpl1(),
				new TestArrayListSetImpl2(),
				new TestArrayListSetIterator1(),
				new TestArrayListSetIterator2(), 
				new TestArrayListSetImpl3(), 	
				
				new TestUnion3(),
				new TestIntersect3(),
				new TestMinus3(),							
		};
	}
	
	public void runTests() {	
		for (AbstractTest test : this.testSuite) {
			this.testCount += test.getTestCount();
			this.testFailed += test.getTestFailedCount();
			this.testSucceeded += test.getTestSucceededCount();
			this.testExpected += test.getTestExpectedCount();
		}
	}
		
}
