package test;

public class TestArrayListSetImpl2 extends AbstractTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException {
        new TestArrayListSetImpl2();
    }

    protected void runTests() {
        this.testExpected = 27;
        try {
            testSuperTypes();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testAddAndSize();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testAddAll();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testContains();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testCopy();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void testSuperTypes() {
        set.ArrayListSetImpl p = new set.ArrayListSetImpl();
        assertInstanceOf(p, set.ObjectSet.class);
    }

    public void testAddAndSize() {
        set.ArrayListSetImpl s = new set.ArrayListSetImpl();
		assertEquals(0, s.size());
		s.add("trotro");		
		assertEquals(1, s.size());
		s.add("ane");		
		assertEquals(2, s.size());
		s.add("trotro");		
		assertEquals(3, s.size());
		s.add(null);
		assertEquals(3, s.size());
    }

    public void testAddAll() { 
        set.ArrayListSetImpl s = new set.ArrayListSetImpl();
        set.ArrayListSetImpl t = new set.ArrayListSetImpl();
		t.addAll(s);
		assertEquals(0, t.size());
		
		s.add("ane");
		s.add("trotro");
		t.addAll(s);
		assertEquals(2, t.size());
		
		s.add("rigolo");
		t.addAll(s);
		assertEquals(5, t.size());
    }

    public void testContains() {
        set.ArrayListSetImpl s = new set.ArrayListSetImpl();
		assertTrue(s.contains("trotro") == false, "'trotro' should not be present");
		s.add("trotro");		
		assertTrue(s.contains("trotro"), "'trotro' must be present");
		s.add("ane");		
		assertTrue(s.contains("trotro"), "'trotro' must be present");
		assertTrue(s.contains("ane"), "'ane' must be present");
		s.add("ane");		
		assertTrue(s.contains("trotro"), "'trotro' must be present");
		assertTrue(s.contains("ane"), "'ane' must be present");
    }

    public void testCopy() {
	    set.ArrayListSetImpl s;
    	set.ObjectSet t;

		s = new set.ArrayListSetImpl();
		t = s.copy();
		assertTrue(s != t, "copy must a different object from the original one");
		assertEquals(0, t.size());
		assertEquals(s.size(), t.size());
		
		s.add("trotro");
		t = s.copy();
		assertTrue(s != t, "copy must a different object from the original one");
		assertEquals(1, t.size());
		assertEquals(s.size(), t.size());
		assertTrue(t.contains("trotro"), "'trotro' must be present in the copy");
		
		s.add("ane");
		t = s.copy();
		assertTrue(s != t, "copy must a different object from the original one");
		assertEquals(s.size(), t.size());
		assertEquals(2, t.size());
		assertTrue(t.contains("trotro"), "'trotro' must be present in the copy");
		assertTrue(t.contains("ane"), "'ane' must be present in the copy");	
    }
}
