package test;

public class TestArraySetIterator2 extends AbstractTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException {
        new TestArraySetIterator2();
    }

    protected void runTests() {
        this.testExpected = 16;
        try {
            testSuperTypes();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testHasNextAndNext();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void testSuperTypes() {
        set.ArraySetIterator p = new set.ArraySetIterator(new Object[] { "dummy" }, 0);
        assertInstanceOf(p, set.SetIterator.class);
    }

    public void testHasNextAndNext() {
        set.ArraySetIterator it = new set.ArraySetIterator(new Object[] { "trop", "trop", "rigolo", null, null }, 0);	
		assertTrue(it.hasNext() == false, "there should be no more element");		
	
        it = new set.ArraySetIterator(new Object[] { }, 0);	
		assertTrue(it.hasNext() == false, "there should be no more element");		

        it = new set.ArraySetIterator(new Object[] { "ane" }, 1);	
		assertTrue(it.hasNext(), "there should be one element");
		assertEquals("ane", it.next());
		assertTrue(it.hasNext() == false, "there should be no more element");		

        it = new set.ArraySetIterator(new Object[] { "ane", null }, 1);	
		assertTrue(it.hasNext(), "there should be one element");
		assertEquals("ane", it.next());
		assertTrue(it.hasNext() == false, "there should be no more element");		
		
        it = new set.ArraySetIterator(new Object[] { "rigolo", "trop", "ane", null, null }, 3);	
		assertTrue(it.hasNext(), "there should be one element");
		assertEquals("rigolo", it.next());
		assertTrue(it.hasNext(), "there should be a second element");
		assertEquals("trop", it.next());
		assertTrue(it.hasNext(), "there should be a third element");
		assertEquals("ane", it.next());
		assertTrue(it.hasNext() == false, "there should be no more element");
    }
}
