package test;

public class TestIntersect2 extends AbstractTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException {
        new TestIntersect2();
    }

    protected void runTests() {
        this.testExpected = 14;
        try {
            testEvaluate();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void testEvaluate() {
        set.ArraySetImpl s = new set.ArraySetImpl(10);
        set.ArraySetImpl t = new set.ArraySetImpl(10);

		set.Intersect i = new set.Intersect(s, t);
		set.ObjectSet res = i.evaluate(); // { } /\ { }
		assertTrue(res != s, "result must be a different object from the first operand");
		assertTrue(res != t, "result must be a different object from the second operand");
		assertEquals(0, res.size());
		assertInstanceOf(res, set.ArraySetImpl.class);
		
		s.add("trotro");
		res = i.evaluate(); // { trotro } /\ { }
		assertEquals(0, res.size());
		
		t.add("trotro");
		res = i.evaluate(); // { trotro } /\ { trotro }
		assertEquals(1, res.size());
		assertTrue(res.contains("trotro"), "result must contain 'trotro'element");
		
        set.ArraySetImpl s2 = new set.ArraySetImpl(10);
		set.Intersect i2 = new set.Intersect(s2, t);
		res = i2.evaluate(); // { } /\ { ane }
		assertEquals(0, res.size());

		s2.add("rigolo");
		s2.add("ane");
		s2.add("trotro");
		s2.add("trop");
		s.add("rigolo");
		s.add("petit");
		s.add("trop");
		set.Intersect i3 = new set.Intersect(s, s2); 
		res = i3.evaluate(); // { trotro, rigolo, petit, trop} /\ { rigolo, ane, trotro, trop }
		assertEquals(3, res.size());
		assertTrue(res.contains("trotro"), "result must contain 'trotro'");
		assertTrue(res.contains("rigolo"), "result must contain 'rigolo'");
		assertTrue(res.contains("petit") == false, "result must not contain 'petit'");
		assertTrue(res.contains("trop"), "result must contain 'trop'");
		assertTrue(res.contains("ane") == false, "result must not contain 'ane'");	
    }
}
