package test;

public class TestMinus2 extends AbstractTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException {
        new TestMinus2();
    }

    protected void runTests() {
        this.testExpected = 14;
        try {
            testEvaluate();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void testEvaluate() {
        set.ArraySetImpl s = new set.ArraySetImpl(10);
        set.ArraySetImpl t = new set.ArraySetImpl(10);

		set.Minus i = new set.Minus(s, t);
		set.ObjectSet res = i.evaluate(); // { } - { }
		assertTrue(res != s, "result must be a different object from the first operand");
		assertTrue(res != t, "result must be a different object from the second operand");
		assertEquals(0, res.size());
		assertInstanceOf(res, set.ArraySetImpl.class);
		
		s.add("trotro");
		res = i.evaluate(); // { trotro } - { }
		assertEquals(1, res.size());
		assertTrue(res.contains("trotro"), "result must contain 'trotro'");
		
		t.add("trotro");
		res = i.evaluate(); // { trotro } - { trotro }
		assertEquals(0, res.size());

        set.ArraySetImpl s2 = new set.ArraySetImpl(10);
		set.Minus i2 = new set.Minus(s2, t);
		res = i2.evaluate(); // { } - { trotro }
		assertEquals(0, res.size());

		s2.add("rigolo");
		s2.add("ane");
		s2.add("trotro");
		s2.add("trop");
		s.add("rigolo");
		s.add("petit");
		s.add("trop");
		set.Minus i3 = new set.Minus(s, s2);		
		res = i3.evaluate(); // { trotro, rigolo, petit, trop} - { rigolo, ane, trotro, trop }
		assertEquals(1, res.size());
				
		assertTrue(res.contains("trotro") == false, "result must not contain 'trotro'");
		assertTrue(res.contains("rigolo") == false, "result must not contain 'rigolo'");
		assertTrue(res.contains("petit"), "result must contain 'petit'");
		assertTrue(res.contains("trop") == false, "result must not contain 'trop'");
		assertTrue(res.contains("ane") == false, "result must not contain 'ane'");	
    }
}
