package test;

public class TestObjectSet extends AbstractTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException {
        new TestObjectSet();
    }

    protected void runTests() {
        this.testExpected = 11;
        try {
            testClass();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testDeclaredMethods();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void testClass() {
		assertInterface(set.ObjectSet.class, "ObjectSet must be an interface");	
    }

    public void testDeclaredMethods() {
        assertDeclaredMethod(set.ObjectSet.class, "add", new Class[]{ Object.class}, "missing method add() in interface ObjectSet / or wrong parameter type");
        assertReturnType(set.ObjectSet.class, "add", new Class[]{ Object.class }, new Class[] { void.class }, "return type of method add() should be void in interface ObjectSet");

        assertDeclaredMethod(set.ObjectSet.class, "addAll", new Class[]{ set.ObjectSet.class }, "missing method addAll() in interface ObjectSet / or wrong parameter type");
        assertReturnType(set.ObjectSet.class, "addAll", new Class[]{ set.ObjectSet.class }, new Class[] { void.class}, "return type of method addAll() should be void in interface ObjectSet");

        assertDeclaredMethod(set.ObjectSet.class, "contains", new Class[]{ Object.class }, "missing method contains() in interface ObjectSet / or wrong parameter type");
        assertReturnType(set.ObjectSet.class, "contains", new Class[]{ Object.class }, new Class[] { boolean.class}, "return type of method contains() should be void in interface ObjectSet");

        assertDeclaredMethod(set.ObjectSet.class, "size", new Class[]{ }, "missing method size() in interface ObjectSet / or wrong parameter type");
        assertReturnType(set.ObjectSet.class, "size", new Class[]{ }, new Class[] { int.class}, "return type of method size() should be int in interface ObjectSet");

        assertDeclaredMethod(set.ObjectSet.class, "copy", new Class[]{ }, "missing method copy() in interface ObjectSet / or wrong parameter type");
        assertReturnType(set.ObjectSet.class, "copy", new Class[]{ }, new Class[] { set.ObjectSet.class}, "return type of method copy() should be int in interface ObjectSet");
    }
}
