package test;

public class TestUnion2 extends AbstractTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException {
        new TestUnion2();
    }

    protected void runTests() {
        this.testExpected = 17;
        try {
            testEvaluate();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void testEvaluate() {
        set.ArraySetImpl s = new set.ArraySetImpl(10);
        set.ArraySetImpl t = new set.ArraySetImpl(10);

		set.Union u = new set.Union(s, t);
		set.ObjectSet res = u.evaluate(); // { } U { }
		assertTrue(res != s, "result must be a different object from the first operand");
		assertTrue(res != t, "result must be a different object from the second operand");
		assertEquals(0, res.size());
		assertInstanceOf(res, set.ArraySetImpl.class);
		
		s.add("trotro");
		res = u.evaluate(); // { trotro } U { }
		assertEquals(1, res.size());
		assertTrue(res.contains("trotro"), "result must contains element from the first operand");
		
		t.add("ane");
		res = u.evaluate(); // { trotro } U { ane }
		assertEquals(2, res.size());
		assertTrue(res.contains("trotro"), "result must contains element from the first operand");
		assertTrue(res.contains("ane"), "result must contains element from the second operand");
		
        set.ArraySetImpl s2 = new set.ArraySetImpl(10);
		set.Union u2 = new set.Union(s2, t);
		res = u2.evaluate(); // { } U { ane }
		assertEquals(1, res.size());
		assertTrue(res.contains("ane"), "result must contains element from the second operand");
		
		s.add("rigolo");
		s.add("est");
		t.add("trop");
		res = u.evaluate(); // { trotro, est, rigolo } U { ane, trop }
		assertEquals(5, res.size());
		assertTrue(res.contains("trotro"), "result must contains element from the first operand");
		assertTrue(res.contains("rigolo"), "result must contains element from the first operand");
		assertTrue(res.contains("est"), "result must contains element from the first operand");
		assertTrue(res.contains("ane"), "result must contains element from the second operand");
		assertTrue(res.contains("trop"), "result must contains element from the second operand");		
    }
}
